"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.objToString = exports.dateConverter = exports.defaultHookSet = void 0;
const fs = __importStar(require("fs"));
const freqMap = ['', 'never', 'yearly', 'monthly', 'weekly', 'daily', 'hourly', 'always'];
const defaultWarningHandler = (msg) => {
    throw new Error(msg);
};
const defaultFileHandler = fs.writeFileSync;
exports.defaultHookSet = {
    defaultWarningHandler,
    defaultFileHandler
};
function dateConverter(date) {
    return new Date(date).toISOString();
}
exports.dateConverter = dateConverter;
function objToString(url, warningHandler) {
    let ele;
    ele = `<loc>${url.loc.toString()}</loc>`;
    if (url.lastmod) {
        ele = ele + `<lastmod>${new Date(url.lastmod).toISOString()}</lastmod>`;
    }
    if (url.priority) {
        if (!(url.priority >= 0 && url.priority <= 1)) {
            warningHandler(`The priority of ${url.loc}(${url.priority}) is invalid. Expected value ranges from 0 to 1.`);
        }
        ele = ele + `<priority>${url.priority}</priority>`;
    }
    if (url.changefreq) {
        if (!((typeof (url.changefreq) === 'number' && url.changefreq >= 1 && url.changefreq <= 7) ||
            (typeof (url.changefreq) === 'string' && freqMap.indexOf(url.changefreq) > 0))) {
            warningHandler(`The changefreq of ${url.loc}(${url.changefreq}) is invalid. Expected a string or a number ranges from 1 to 7. See https://github.com/CBW2007/sitemap-manager/wiki/Types#urlobj`);
        }
        ele = ele + `<changefreq>${(typeof (url.changefreq) === 'number') ? freqMap[url.changefreq] : url.changefreq}</changefreq>`;
    }
    return ele;
}
exports.objToString = objToString;
